"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

Object.defineProperty(exports, "__esModule", { value: true });
var event_1 = require("../event");

var ReduxChangeEvent = function (_event_1$BaseEvent) {
    _inherits(ReduxChangeEvent, _event_1$BaseEvent);

    function ReduxChangeEvent() {
        _classCallCheck(this, ReduxChangeEvent);

        return _possibleConstructorReturn(this, (ReduxChangeEvent.__proto__ || Object.getPrototypeOf(ReduxChangeEvent)).apply(this, arguments));
    }

    return ReduxChangeEvent;
}(event_1.BaseEvent);

exports.ReduxChangeEvent = ReduxChangeEvent;

var ReduxListener = function () {
    function ReduxListener(eventBus) {
        var _this2 = this;

        _classCallCheck(this, ReduxListener);

        this.eventBus = eventBus;
        this.listener = function () {
            _this2.eventBus.emit(new ReduxChangeEvent(_this2.store.getState()));
        };
    }

    _createClass(ReduxListener, [{
        key: "subscribeReduxStore",
        value: function subscribeReduxStore(store) {
            this.unsubscribe = store.subscribe(this.listener);
        }
    }, {
        key: "unsubscribeReduxStore",
        value: function unsubscribeReduxStore() {
            this.unsubscribe && this.unsubscribe();
        }
    }, {
        key: "change",
        value: function change(store) {
            this.unsubscribeReduxStore();
            this.subscribeReduxStore(store);
            this.store = store;
        }
    }]);

    return ReduxListener;
}();

exports.ReduxListener = ReduxListener;
//# sourceMappingURL=ReduxListener.js.map